#ifndef __Array_H__
#define __Array_H__

#include <iostream>
using namespace std;

template<int I, class T> class Array {

public:
	Array();
	Array( const Array<I,T>& arr );
	~Array();
	
public:
	void operator=( const Array<I,T>& rhs ) { memcpy( values_, rhs.values_, sizeof( T ) * I ); };
	void operator=( T rhs );
	const T& operator[]( int i ) const { assert( 0 <= i && i < I ); return values_[ i ]; };
	      T& operator[]( int i )       { assert( 0 <= i && i < I ); return values_[ i ]; };
	
public:
	      T* values()       { return values_; };
	const T* values() const { return values_; };
	int size() const { return I; };

protected:
	T values_[ I ];

};

template<int I, class T> Array<I,T>::Array() {
	
}

template<int I, class T> Array<I,T>::Array( const Array<I,T>& arr ) {
	*this = arr;
}

template<int I, class T> Array<I,T>::~Array() {

}

template<int I, class T> void Array<I,T>::operator=( T rhs ) {
	for ( int i = 0; i < size(); i++ )
		values_[ i ] = rhs;
}

template<int I, class T> ostream& operator<<( ostream& output, const Array<I,T>& arr ) {
	for ( int i = 0; i < arr.size(); i++ ) {
		if ( i != 0 ) output << " ";
		output << arr[ i ];
	}
	return output;
}

#endif // __Array_H__
