#ifndef __BinaryOperator_H__
#define __BinaryOperator_H__

#include "Function.h"

template<class T> class BinaryOperator : public Function<T> {

public:
	BinaryOperator( const char* name, void (*binary_op)(const T& a, const T& b, T& output ) );
	virtual ~BinaryOperator();
	
public:
	void execute( const auto_list<T>& inputs, T& output ) { binary_op_( inputs[ 0 ], inputs[ 1 ], output ); };
	
protected:
	void (*binary_op_)(const T& a, const T& b, T& output );

};

template<class T> BinaryOperator<T>::BinaryOperator( const char* name, void (*binary_op)(const T& a, const T& b, T& output ) )
 : Function<T>::Function( name, 2 ),
   binary_op_( binary_op )
{

}

template<class T> BinaryOperator<T>::~BinaryOperator() {
	binary_op_ = NULL;
}

#endif // __BinaryOperator_H__
