#ifndef __Constant_H__
#define __Constant_H__

#include "Function.h"

template<class T> class Constant : public Function<T> {

public:
	Constant( const char* name, T c );
	virtual ~Constant();
	
public:
	void execute( const auto_list<T>& inputs, T& output ) { output = c_; };
	
protected:
	const T c_;

};

template<class T> Constant<T>::Constant( const char* name, T c )
 : Function<T>::Function( name, 0 ),
   c_( c )
{

}

template<class T> Constant<T>::~Constant() {

}

#endif // __Constant_H__
