#ifndef __ConstantInt_H__
#define __ConstantInt_H__

#include "Function.h"
#include "ImageArray.h"

class ConstantInt : public Function<ImageArray> {

public:
	ConstantInt( const char* name, int c );
	virtual ~ConstantInt();
	
public:
	void execute( const auto_list<ImageArray>& inputs, ImageArray& output ) const { output.image() = c_; };
	
protected:
	const int c_;

};

ConstantInt::ConstantInt( const char* name, int c )
 : Function<ImageArray>::Function( name, 0 ),
   c_( c )
{

}

ConstantInt::~ConstantInt() {

}

#endif // __Constant_H__
