#ifndef __Evaluation_H__
#define __Evaluation_H__

#include <string>
using namespace std;

// forward declaration
template<class T> class Candidate;

template<class T> class Evaluation {

public:
	Evaluation() {};
	virtual ~Evaluation() {};
	
public:
	static int TEST_CASES;
	static int EPOCH_LENGTH;
	static string EVAL_FUNCTION;
	
public:
	virtual double evaluate( Candidate<T>& candidate ) = 0;
	virtual void   initialise( int num_cases = TEST_CASES ) = 0;
	
};

template<class T> int Evaluation<T>::TEST_CASES  = 10;
template<class T> int Evaluation<T>::EPOCH_LENGTH = 1000;
template<class T> string Evaluation<T>::EVAL_FUNCTION( "ImagesEvaluation" );

#endif // __Evaluation_H__
