#ifndef __Function_H__
#define __Function_H__

#include <iostream>
using namespace std;

#include "auto_list.h"

template<class T> class Function {

public:
	Function( const char* name, int arity, bool adf = false );
	virtual ~Function();
	
public:
	const char* name() const { return name_; };
	int arity() const { return arity_; };
	bool is_adf() const { return adf_; };
	virtual void execute( const auto_list<T>& inputs, T& output ) = 0;
	
protected:
	char* name_;
	int arity_;
	bool adf_;
};

template<class T> Function<T>::Function( const char* name, int arity, bool adf )
 : name_( NULL ),
   arity_( arity ),
   adf_( adf )
{
	name_ = new char[ strlen( name ) +1 ];
	strcpy( name_, name );
}

template<class T> Function<T>::~Function() {

}

template<class T> ostream& operator<<(ostream& output, const Function<T>& function ) {
	output << function.name();
    return output;
}


#endif // __Function_H__
