#ifndef __ImageArrayOperators_H__
#define __ImageArrayOperators_H__

#include "ImageArray.h"

// binary operators
void add_op( const ImageArray& a, const ImageArray& b, ImageArray& output );

void sub_op( const ImageArray& a, const ImageArray& b, ImageArray& output );

void mul_op( const ImageArray& a, const ImageArray& b, ImageArray& output );

void div_op( const ImageArray& a, const ImageArray& b, ImageArray& output );

void gt_op( const ImageArray& a, const ImageArray& b, ImageArray& output );

void lt_op( const ImageArray& a, const ImageArray& b, ImageArray& output );

void max_op( const ImageArray& a, const ImageArray& b, ImageArray& output );

void min_op( const ImageArray& a, const ImageArray& b, ImageArray& output );

void diff_op( const ImageArray& a, const ImageArray& b, ImageArray& output );


// unary operators
void abs_op( const ImageArray& input, ImageArray& output );

void neg_op( const ImageArray& input, ImageArray& output );

void avg_op( const ImageArray& input, ImageArray& output );

void cen_op( const ImageArray& input, ImageArray& output );

void peak_op( const ImageArray& input, ImageArray& output );

void gauss_op( const ImageArray& input, ImageArray& output );

void erode_op( const ImageArray& input, ImageArray& output );

void dilate_op( const ImageArray& input, ImageArray& output );

// ternary operators
void canny_op( const ImageArray& input, const ImageArray& threshold1, const ImageArray& threshold2, ImageArray& output );

void features_op( const ImageArray& input, const ImageArray& quality, const ImageArray& distance, ImageArray& output );

#endif // __ImageArrayOperators_H__
