#ifndef __ImageMinimalSim_H__
#define __ImageMinimalSim_H__

#include "Candidate.h"
#include "MinimalSimulation.h"
#include "ImageArray.h"

class ImageMinimalSim : public MinimalSimulation {

public:
	ImageMinimalSim();
	virtual ~ImageMinimalSim();

public:
	void initialise();
	double evaluate( Candidate<ImageArray>& candidate );

protected:
	void render( Image& buffer, int x, int y );
	double evaluateStatic( Candidate<ImageArray>& candidate );

public:
	static int NOISE;

protected:
	Image background_;
	Image object_;
	int start_x_;
	int start_y_;
	
	Image buffer_;
};

#endif // __ImageMinimalSim_H__
