#ifndef __ImagesEvaluation_H__
#define __ImagesEvaluation_H__

#include "Evaluation.h"
#include "ImageArray.h"
#include "auto_list.h"

#include <iostream>
#include <vector>
#include <string>
using namespace std;

struct ImageTestCase {
	Image image;
	CvPoint target[ 4 ];
};

class ImagesEvaluation : public Evaluation<ImageArray> {

public:
	ImagesEvaluation( ImageArray& input0, ImageArray& input1, const char* images_dir );
	virtual ~ImagesEvaluation();

public:
	void initialise( int numcases = TEST_CASES );

public:
	double evaluate( Candidate<ImageArray>& candidate );

public:
	static string IMAGES_DIR;

protected:
	ImageArray& input0_;
	ImageArray& input1_;

	auto_list< ImageTestCase > testCases_; 
	vector< string > fileNames_;
	vector< vector<int> > targetCoords_;
};

#endif // __ImagesEvaluation_H__
