#include "MinimalSimEvaluation.h"
#include "Candidate.h"

//#include "ImageMinimalSim.h"
#include "MotionMinimalSim.h"

#include <iostream>
using namespace std;

string MinimalSimEvaluation::DATA_FILE( "none" );

MinimalSimEvaluation::MinimalSimEvaluation()
 : numsims_( -1 )
{
	initialise();
}

MinimalSimEvaluation::~MinimalSimEvaluation() {
	
}
	

double MinimalSimEvaluation::evaluate( Candidate<ImageArray>& candidate ) {
	double best  = 0.0;
	double worst = 0.0;
	double sum   = 0.0;
	for ( int i = 0; i < numsims_; i++ ) {
		double score = simulations_[ i ].evaluate( candidate );
		if ( i == 0 )
			best = score;
		else
			best  = min( score, best  );
		worst = max( score, worst );
		sum += score;
	}
	return sum/numsims_;
}

void MinimalSimEvaluation::initialise( int numsims ) {
	if ( numsims != numsims_ ) {
		numsims_ = numsims;
		simulations_.clear();
		for ( int i = 0; i < numsims_; i++ ) {
			simulations_.add( new MotionMinimalSim() );
		}
	}

	//cout << "numsims_=" << numsims_ << "=" << simulations_.size() << endl;
	for ( int i = 0; i < numsims_; i++ ) {
		if ( DATA_FILE == "none" || DATA_FILE == "" )
			simulations_[ i ].initialise();
		else
			simulations_[ i ].initialise( DATA_FILE.c_str() );
	}
}
