#ifndef __MotionMinimalSim_H__
#define __MotionMinimalSim_H__

#include "MinimalSimulation.h"

#include "Image.h"

class MotionMinimalSim : public MinimalSimulation {

public:
	MotionMinimalSim();
	virtual ~MotionMinimalSim();
	
public:

	void initialise();
	void initialise( const char* file );
	double evaluate( Candidate<ImageArray>& candidate );
	
	double evaluateFunction0( Candidate<ImageArray>& candidate );
	double evaluateFunction1( Candidate<ImageArray>& candidate );
	double evaluateFunction1PureMotion( Candidate<ImageArray>& candidate );

public:
	static bool PURE_MOTION;

protected:
	Image background_;
	Image object_;
	Image buffer_;
	vector<vector2d> positions_;
	vector<Image> noise_;
	vector<Image> images_;
	int epoch_;
	bool realData_;
};

#endif //__MotionMinimalSim_H__
