#include "Properties.h"

//#include <fstream>
//using namespace std;

Properties::Properties( istream& input ) {
	while ( !input.eof() ) {
		string key;
		char c = ' ';
		string value;
		
		input >> key >> c >> value;
		
		if ( key != "" && key[ 0 ] != '#' ) {
			values_[ key ] = value;
			add_key( key );
		}
	}
	
	for ( unsigned int i = 0; i < keys_.size(); i++ ) {
		cout << keys_[ i ] << " = " << values_[ keys_[ i ] ] << endl;
	}
}

string Properties::get( const char* key, const char* defValue ) {
	string defStr( defValue );
	return get( key, defStr );
}


void Properties::add_key( string key ) {
	for ( unsigned int i = 0; i < keys_.size(); i++ ) {
		if ( keys_[ i ] == key ) return;
	}
	keys_.push_back( key );
}

string Properties::get( const char* key, string defValue ) {
	string keystr = key;
	string& value = values_[ keystr ];
	if ( value == "" ) {
		add_key( keystr );
		value = defValue;
	}
	return value;
}

int Properties::get( const char* key, int defValue ) {
	string value = get( key, "" );
	if ( value == "" )
		return defValue;
	return atoi( value.c_str() );
}

double Properties::get( const char* key, double defValue ) {
	string value = get( key, "" );
	if ( value == "" )
		return defValue;
	return atof( value.c_str() );
}

bool Properties::get( const char* key, bool defValue ) {
	string value = get( key, "" );
	return value == "true" || value == "True";
}

/*int main() {
	ifstream params( "params.txt" );
	Properties props( params );
	params.close();
	return 0;
}*/
