#ifndef __Properties_H__
#define __Properties_H__

#include <map>
#include <string>
#include <vector>
#include <iostream>
using namespace std;

class Properties {

public:
	Properties( istream& input );

public:
	string get( const char* key, const char* defValue );
	string get( const char* key, string defValue );
	int    get( const char* key, int    defValue );
	double get( const char* key, double defValue );
	bool   get( const char* key, bool defValue );

	vector<string> keys() const { return keys_; };

protected:
	void add_key( string key );

protected:
	struct ltstr
        {
                bool operator()(string s1, string s2) const
                {
                    return strcmp(s1.c_str(), s2.c_str()) < 0;
                }
        };

        map<string, string, ltstr> values_;
	vector<string> keys_;
};

#endif //__Properties_H__
