#ifndef __TernaryOperator_H__
#define __TernaryOperator_H__

#include "Function.h"

template<class T> class TernaryOperator : public Function<T> {

public:
	TernaryOperator( const char* name, void (*ternary_op)(const T& a, const T& b, const T& c, T& output ) );
	virtual ~TernaryOperator();
	
public:
	void execute( const auto_list<T>& inputs, T& output ) { ternary_op_( inputs[ 0 ], inputs[ 1 ], inputs[ 2 ], output ); };
	
protected:
	void (*ternary_op_)(const T& a, const T& b, const T& c, T& output );

};

template<class T> TernaryOperator<T>::TernaryOperator( const char* name, void (*ternary_op)(const T& a, const T& b, const T& c, T& output ) )
 : Function<T>::Function( name, 3 ),
   ternary_op_( ternary_op )
{

}

template<class T> TernaryOperator<T>::~TernaryOperator() {
	ternary_op_ = NULL;
}

#endif // __BinaryOperator_H__
