#ifndef __UnaryOperator_H__
#define __UnaryOperator_H__

#include "Function.h"

template<class T> class UnaryOperator : public Function<T> {

public:
	UnaryOperator( const char* name, void (*unary_op)(const T& input, T& output) );
	virtual ~UnaryOperator();
	
public:
	void execute( const auto_list<T>& inputs, T& output ) { unary_op_( inputs[ 0 ], output ); };
	
protected:
	void (*unary_op_)(const T& input, T& output );

};

template<class T> UnaryOperator<T>::UnaryOperator( const char* name, void (*unary_op)(const T& input, T& output) )
 : Function<T>::Function( name, 1 ),
   unary_op_( unary_op )
{

}

template<class T> UnaryOperator<T>::~UnaryOperator() {
	unary_op_ = NULL;
}

#endif // __UnaryOperator_H__
