#ifndef __Variable_H__
#define __Variable_H__

#include "Function.h"

template<class T> class Variable : public Function<T> {

public:
	Variable( const char* name, const T& variable );
	virtual ~Variable();
	
public:
	void execute( const auto_list<T>& inputs, T& output ) { output = *variable_; };
	
protected:
	const T* variable_;

};

template<class T> Variable<T>::Variable( const char* name, const T& variable )
 : Function<T>::Function( name, 0 ),
   variable_( &variable )
{

}

template<class T> Variable<T>::~Variable() {
	variable_ = NULL;
}

#endif // __Variable_H__
