#ifndef __VariableNode_H__
#define __VariableNode_H__

#include "GPNode.h"

template<class T> class VariableNode : public GPNode<T> {

public:
	VariableNode( const T& variable );
	virtual ~VariableNode ();
	
public:
	virtual void execute(); 
	
private:
	const T* variable_;
};

///////////////////////
// implementation
///////////////////////

template<class T> VariableNode<T>::VariableNode( const T& variable )
 : GPNode<T>::GPNode(),
   variable_( &variable )
{
	
}

template<class T> VariableNode<T>::~VariableNode() {
    variable_ = NULL;
}
	
template<class T> void VariableNode<T>::execute() {
    output_ = (*variable_);
}

#endif // __VariableNode_H__
