#include "adfs.h"

#include <string>
#include <sstream>
using namespace std;

#include "ADFunction.h"
#include "terminals.h"
#include "functions.h"

void create_adfs( vector<int> adfs, auto_list< ADFunction<ImageArray> >& definedFunctions ) {
	for ( unsigned int i = 0; i < adfs.size(); i++ ) {
		ostringstream strout;
		strout << "fn" << i;
		const char* name = strout.str().c_str();
		int numInputs = adfs[ i ];
		ADFunction<ImageArray>* adf = new ADFunction<ImageArray>( name, numInputs );
		definedFunctions.add( adf );
		create_terminals( adf->terminals() );
		create_functions( adf->functions() );
		
		for ( unsigned int j = 0; j < i; j++ ) {
			ADFunction<ImageArray>& caller = definedFunctions[ j ];
			ADFunction<ImageArray>* adfCopy = new ADFunction<ImageArray>( *adf );
			if ( adfCopy->arity() == 0 )
				caller.terminals().add( adfCopy );
			else
				caller.functions().add( adfCopy );
		}
		
	}
}

