#!/bin/bash

for i in `seq 1 5`
do
	files="*.o*.$i"
	resultsfile="results${i}.csv"
	for file in $files
	do
		echo $file;
		cat $file | ./extractCSV.pl > ${file}.csv;
	done
	rm $resultsfile
	touch $resultsfile
	for file in $files
	do
		tail -n 1 ${file}.csv >> $resultsfile
		head -n $(( $(cat ${file}.csv | wc -l) - 1 )) ${file}.csv > ${file}.csv~
		mv ${file}.csv~ ${file}.csv
	done
	python makecharts.py -dPS *.o*.${i}.csv -run:${i}
	python makecharts.py -dGD *.o*.${i}.csv -run:${i}
done

for ps in *.ps
do
	ps2epsi "$ps"
done

for filetype in csv ps png epsi
do
	rm -rf $filetype
	mkdir $filetype
	mv *.$filetype $filetype
done

