#!/usr/bin/python
import sys
import string
from matplotlib.matlab import plot, xlabel, ylabel, title, savefig, figure, legend, show, axis, close

def plot_multi_series( charttitle, xseries, yseries ):
	print "Plotting '" + charttitle + "'"
	figure()
	#styles = [ 'k-', 'k--', 'b-', 'b--', 'g-', 'g--' ]
	styles = [ 'k-', 'b-', 'g-', 'r-', 'k--', 'b--', 'g--', 'r--' ]
	graphs = []
	style = 0
	for i,x,y in zip( range( len( xseries ) ), xseries, yseries ):
		graphs.append( x )
		graphs.append( y )
		#graphs.append( 'k-' )
		graphs.append( styles[ style ] )
		style = style+1
	apply( plot, tuple( graphs ) )
	#xlabel( xname )
	#ylabel( yname )
	title( charttitle )
	#legend( series_names )
	#show()
	#axes = axis()
	#if axes[ 3 ] > 1000:
	#	axes[ 3 ] = 1000
	#	axis( axes )
	savename = string.replace( charttitle, ' ', '_' )
	savename = string.replace( savename, '(', '-' )
	savename = string.replace( savename, ')', '-' )
	savefig( savename )
	close()

def chart_fitness_size( dataseries ):
	iterations = []
	fitness    = []
	size       = []
	
	for i in range( 0, len( dataseries), 3 ):
		iterations.append( dataseries[ i ] )
		fitness.append( dataseries[ i+1 ] );
		size.append( dataseries[ i+2 ] );		
	plot_multi_series( "Program Size  (Run " + runnumber + ")",  iterations, size )
	plot_multi_series( "Squared Error (Run " + runnumber + ")", iterations, fitness ) 

def make_charts( filenames ):
	dataseries = []
	
	for filename in filenames:
		print "Processing: " + filename
		file = open( filename, "r" )
		lines = file.readlines()
		file.close()
		print str( len( lines ) ) + " lines"
		if len( lines ) == 0:
			return
		columnlabels = string.split( lines[ 0 ], ',' )
		numcolumns = len( columnlabels )
		print str( numcolumns ) + " columns"
		
		columnsstart = len( dataseries )
		columnnums = range( 0, numcolumns )
		for i in columnnums:
			dataseries.append( [] )
	
		for line in lines:
			values = map( (lambda v: float( v )), string.split( line, ',' ) )
			for i in columnnums:
				dataseries[ i+columnsstart ].append( values[ i ] )
		lines = []
	
	print "dataseries: " + str( len( dataseries ) )
	#print dataseries
	chart_fitness_size( dataseries )
		
	

files = []
runnumber = 0

for i in range( 1, len(sys.argv)):
	if string.find( sys.argv[ i ], "-" ) != 0:
		files.append( sys.argv[ i ] )
	elif string.find( sys.argv[ i ], "-run:" ) == 0:
		runnumber = string.split( sys.argv[ i ], ":" )[ 1 ]

if len( files ) != 0:
	make_charts( files )
else:
	print "You must specify a file to process"



