#include "terminals.h"

#include <string>
#include <sstream>
using namespace std;

#include "GPProgram.h"
#include "Constant.h"
#include "Variable.h"

void create_terminals( auto_list< Function<ImageArray> >& terminals ) {
	vector<string>& constants = GPProgram<ImageArray>::CONSTANTS;
	for ( unsigned int i = 0; i < constants.size(); i++ ) {
		string constanti = constants[ i ];
		double value = 0.0;
		istringstream strin( constanti );
		strin >> value;
		//cout << constants[ i ] << "=" << value << endl;
		ImageArray constant;
		constant = value;
		terminals.add( new Constant<ImageArray>( constanti.c_str(), constant ) );
	}
}
