#ifndef __vector2d_H__
#define __vector2d_H__

#include <iostream>
using namespace std;

class vector2d {

public:
	vector2d();
	vector2d( double nx, double ny );

public:

	double dotProduct( const vector2d& v ) const;
	double dotProduct() const;
	double magnitude() const;
	
	const vector2d& operator=( double s );
	
	vector2d operator+( const vector2d& v ) const;
	vector2d operator-( const vector2d& v ) const;
	vector2d operator*( const vector2d& v ) const;
	vector2d operator/( const vector2d& v ) const;

	vector2d operator+( double s ) const;
	vector2d operator-( double s ) const;
	vector2d operator*( double s ) const;
	vector2d operator/( double s ) const;

	vector2d abs() const;
public:
	double x;
	double y;
};

vector2d operator+( double s, const vector2d& v );
vector2d operator-( double s, const vector2d& v );
vector2d operator*( double s, const vector2d& v );
vector2d operator/( double s, const vector2d& v );

istream& operator>>( istream& input,  vector2d& v );
ostream& operator<<( ostream& output, const vector2d& v );

#endif // __vector2d_H__
